<?xml version="1.0" encoding="UTF-8"?>
<project name="MTJ ISV Documentation Build" default="all" basedir=".">

	<target name="init">
		<available file="${basedir}/index" property="index.present" />
	</target>

	<target name="all" depends="init" unless="index.present">
		<antcall target="convertSchemaToHtml" />
		<antcall target="generateJavadoc" />
		<antcall target="build.index" />
	</target>


	<target name="build.index" description="Builds search index for the plug-in: org.eclipse.mtj.doc.isv" if="eclipse.running">
		<help.buildHelpIndex manifest="${basedir}/plugin.xml" destination="${basedir}" />
	</target>

	<target name="convertSchemaToHtml" if="eclipse.running">
		<property name="dest" value="html/reference/extension-points" />

		<record name="${basedir}/mtjconvert.txt" action="start" />
		<pde.convertSchemaToHTML manifest="../org.eclipse.mtj.core/plugin.xml" destination="${dest}" />
		<pde.convertSchemaToHTML manifest="../org.eclipse.mtj.ui/plugin.xml" destination="${dest}" />
		<record name="${basedir}/mtjconvert.txt" action="stop" />
	</target>

	<target name="getJavadocPath">
		<available file="${java.home}/../bin/javadoc.exe" property="javadoc" value="${java.home}/../bin/javadoc.exe" />
		<available file="${java.home}/../bin/javadoc" property="javadoc" value="${java.home}/../bin/javadoc" />
	</target>

	<target name="generateJavadoc" depends="getJavadocPath" if="javadoc">

		<property name="optionsFile" value="mtjOptions.tmp.txt" />
		<copy file="mtjOptions.txt" tofile="${optionsFile}" overwrite="true" />

		<condition property="argsListDelimiter" value=":">
			<os family="unix" />
		</condition>
		<condition property="argsListDelimiter" value=";">
			<os family="windows" />
		</condition>

		<replaceregexp file="${basedir}/${optionsFile}" flags="g" match="(\r\n?|\n);" replace="${argsListDelimiter}" />
		<replace file="${basedir}/${optionsFile}" token="@rt@" value="${bootclasspath}" />

		<!--scrub isv plugin directories of any preexisting api doc content-->
		<delete dir="html/reference/api" />
		<mkdir dir="html/reference/api" />

		<exec dir="." executable="${javadoc}" output="doc.bin.log">
			<arg line="@${basedir}/${optionsFile} -J-Xmx1000M" />
		</exec>
	</target>
</project>

